mob
	proc
		attack(mob/M)
			if(M) // always check if M is there
				src << "<font color = #a1ff00>You attempt to attack [M]."
				M << "<font color = #a1ff00>[src] attempts to attack you."
				sleep(10)
				if(rand(1,4)==4) // just some mini-dodging  you can change this if you want
					src << "<font color = #a1ff00>[M] dodges your attack."
					M << "<font color = #a1ff00>You dodge [src]'s attack."
				else
					var/damage = src.str - M.def // just like any RPG, strength minus defense equals damage =D
					if(damage<=0)
						damage = 1 // now if you're too weak, you don't heal them
					if(luckchance(src)) // criticles, the main procedure is in Main.dm
						damage = damage*2
						src << "<font color = #ef2100>Criticle hit!"
						M << "<font color = #ef2100>Criticle hit!"
						sleep(10)
					src << "<font color = #a1ff00>You hit [M] for [damage] damage."
					M << "<font color = #a1ff00>[src] hits you for [damage] damage."

					M.hp -= damage
					sleep(10) // this is so it doesn't get cluttered

					// deathcheck will be called in the actual battle, so less space is taken in the long run
		bighit(mob/M)
			if(M)
				src << "<font color = #a1ff00>You attempt to bighit [M]."
				M << "<font color = #a1ff00>[src] attempts to bighit you."
				sleep(10)
				if(rand(1,2)==2) // lower chance of hitting
					src << "<font color = #a1ff00>[M] dodges your attack."
					M << "<font color = #a1ff00>You dodge [src]'s attack."
				else
					var/damage = (src.str - M.def) + 15 // bigger damage, the ( and ) aren't needed but I use
					if(damage<=0)                       // them so it is more organised
						damage = 1
					if(luckchance(src)) // I wonder what'll happen if you criticle this o.O
						damage = damage*2
						src << "<font color = #ef2100>Criticle hit!"
						M << "<font color = #ef2100>Criticle hit!"
						sleep(10)

					src << "<font color = #a1ff00>You hit [M] for [damage] damage."
					M << "<font color = #a1ff00>[src] hits you for [damage] damage."

					M.hp -= damage
					sleep(10)

		wave(mob/M) // this proc is pretty much simular to attack and bighit, but there is just a different
				   // damage counter and it checks for your magic
			if(M)
				src << "<font color =#9c3ae0>You mentally attack [M] using Mental Wave."
				M << "<font color = #9c3ae0>[src] attempts to mentally attack you."
				sleep(10)
				if(src.mp<5) // you can't just spam zap and never loose magic!
					src << "<font color = #9c3ae0>... but you need at least 5 MP to cast Mental Wave!"
					M << "<font color = #9c3ae0>... but [src] doesn't have enough magic left!"

				else
					src.mp -= 5
					var/damage = src.int + 5 - round(M.int/2) // this is just for fun, there is magic defence too
					if(damage<=0) // unless you're immune to electricity, I suggest you keep this there
						damage = 1
					src << "<font color = #9c3ae0>You attack [M] for [damage] damage using Mental Wave."
					M << "<font color = #9c3ae0>[src] attacks you for [damage] damage using Mental Wave."
					M.hp -= damage
					M.overlays += image('spell_effects.dmi',"mentalwave") // check out the F1 reference for more details about this proc
					sleep(5)									   // we use sleep() because this is a realtime.  if we don't sleep, the battle will zoom out ahead before you can read it all
					M.overlays -= image('spell_effects.dmi',"mentalwave") // some things are meant to die sooner or later

		blast(mob/M)
			if(M)
				src << "<font color = #9c3ae0>You attempt to mentally attack [M] using Blast."
				M << "<font color = #9c3ae0>[src] attempts to mentally attack you using Blast."
				sleep(10)
				if(src.mp<10)
					src << "<font color = #9c3ae0>... but you need at least 10 MP to cast bang!"
					M << "<font color = #9c3ae0>... but [src] doesn't have enough magic left!"

				else
					src.mp -= 10
					var/damage = src.int + 10 - round(M.int/2) // bigger and better damage
					if(damage<=0)
						damage = 1
					src << "<font color = #9c3ae0>You attacks [M] for [damage] damage using Blast."
					M << "<font color = #9c3ae0>[src] attacks you for [damage] damage using Blast."
					M.hp -= damage
					M.overlays += image('spell_effects.dmi',"blast")
					sleep(5)
					M.overlays -= image('spell_effects.dmi',"blast")



		heal(mob/M)
			src << "<font color = #9c3ae0>You cast heal."
			M << "<font color = #9c3ae0>[src] casts heal."
			sleep(10)
			if(src.mp<7)
				src << "<font color = #9c3ae0>... but you need at least 7 MP to cast heal!"
				M << "<font color = #9c3ae0>... but [src] doesn't have enough magic left!"

			else
				src.mp -= 7
				var/gain = src.int+7 //
				src << "<font color = #9c3ae0>You recover [gain] Health."
				M << "<font color = #9c3ae0>[src] recovers [gain] Health."
				src.hp += gain
//				if(src.hp > src.maxhp) src.hp = src.maxhp // You can still use this way to do this, but the following way is better and more efficient
				src.hp = min(src.maxhp,src.hp+gain) // this prodecure returns the smaller value
													// the max() proc takes the bigger value, for future reference
				src.overlays += image('spell_effects.dmi',"heal")
				sleep(5)
				src.overlays -= image('spell_effects.dmi',"heal")
